# An UDP server

import thread
import socket
from defaultRecvHandler import defaultRecvHandler
from time import sleep

class UDPServer:
  def __init__(self, ip, port):
    self.addr = (ip, port)
    self.granularity = 1.0 / 60.0
    self.recvBufferSize = 2048  
    self.recvHandler = defaultRecvHandler
    # Create the server socket and bind it
    self.socket = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    self.socket.bind(self.addr)

  def start(self):
    self.stopRecvThread = 0
    thread.start_new_thread(self.__recv, ())

  def stop(self):
    self.stopRecvThread = 1

  def setRecvHandler(self, handler):
    self.recvHandler = handler
    
  ### Private methods ###

  def __recv(self):
    while not self.stopRecvThread:
      data = self.socket.recv(self.recvBufferSize)
      if data:
        a = self.recvHandler()
        a.handle(data)
      sleep(self.granularity)
